#ifndef _SUPPORT_
#define _SUPPORT_

#include "UDCF.h"

#ifndef __cplusplus
#include "bool.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* ---- Init a group of dives (Group of repetitive dives) ---- */
void InitRepGroup(UDCFGroup* group);

/* ---- Get the pointer to actual profile struct ---- */
UDCF* GetProfile();

/* ---- Get the last used RepGroup ---- */
UDCFGroup* GetLastRepGroup();

/* ---- Init a single mix struct ---- */
void InitMix(UDCFMix* mix);

/* ---- Init a single dive ---- */
void InitDive(UDCFDive* dive);

/* ---- Get the last used mix ---- */
UDCFMix* GetLastMix();

/* ---- Get the index to mix with name 'mixName' ---- */
long FindMix(UDCFDive* dive, const char* mixName);

/* ---- Check if 'mix' is a valid one (pO2 + pN2 + pHe = 1.0) ---- */
bool IsCorrectMix(UDCFMix* mix);

/* ---- Get the last used dive ---- */
UDCFDive* GetLastDive();

/* ---- Init a sample ---- */
void InitSample(UDCFSample* sample);

/* ---- Add new entry's in the corresponding dynamic array's ---- */
void CreateNewSample();
void CreateNewDive();
void CreateNewRepGroup();
void CreateNewMix();

/* ---- Resize (increase only) the dynamic array's ---- */
void increaseSample();
void increaseDive();
void increaseGroup();
void increaseMix();

/* ---- Do a strcpy without buffer overflow ---- */
char* saveStrDup(char* s);

#ifndef NDEBUG
/* ---- Print a dive (Debug-Mode) ---- */
void PrintDive(UDCFDive* dive);
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */                                                       

#endif

