//-*-C++-*-
#ifndef _COLORRANGE_
#define _COLORRANGE_

#include <gdk--/color.h>

#include <vector>

class ColorRange
{
 public:

  /* ---- Map the interval [min..max] to the colors from [minColor..maxColor] ---- */
  /* ---- Use "numColors" colors for that mapping                             ---- */
  ColorRange(int min, 
             int max, 
             unsigned int numColors, 
             Gdk_Color* minColor, 
             Gdk_Color* maxColor);

  /* ---- DTor ---- */
  ~ColorRange();

  /* ---- Get the color corresponding to "value" ---- */
  Gdk_Color* getColor(int value);
  
  /* ---- Get the color corresponding to "index" ---- */
  Gdk_Color* getColorByIndex(int index);

 private:

  /* ---- Convert a value in the range min..max into a corresponding index ---- */
  int ColorRange::calcIndex(int value);

  /* ---- Array for allocated colors ---- */
  vector<Gdk_Color*> colorArray;

  /* ---- The range parameters ---- */ 
  int min;
  int max;
  unsigned int numColors;

};
#endif
