//-*-C++-*-  
#include <gtk--/accelgroup.h>
#include <gtk--/alignment.h>
#include <gtk--/box.h>
#include <gtk--/label.h>
#include <gtk--/menu.h>
#include <gtk--/menubar.h>
#include <gtk--/fileselection.h>
#include <gtk--/entry.h>


#include <SimpleRequest.h>
#include <UCS.h>
#include <MainWindow.h>
#include <UDCF.h>

#include <config.h>

#include <iostream>
#include <strstream>
#include <string>
#include <cmath>

#include <errno.h>
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>

#define MainMenuPath "<Main>"

#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

MainWindow::MainWindow() 
{
 /* ---- Init the profile handle ---- */
 profile = static_cast<UDCF*>(NULL);

 /* ---- Init the temporal dive pointer ---- */
 dive = static_cast<UDCFDive*>(NULL);

 /* ---- At the moment we have no valid profile ----- */
 haveValidProfile = false;

 /* ---- Init the index for group and dive which will be shown ---- */
 actGroup = 0; 
 actDive = 0;

 /* ---- Create a vbox object ---- */
 vbox = new Gtk::VBox(FALSE, 1);

  /* ---- Check for success ---- */
 if (vbox == (Gtk::VBox*) NULL) exit(EXIT_FAILURE);

 /* ---- Add the vbox  ---- */
 add(*vbox);

 /* ---- Build the menu ---- */
 makeMenu();

 /* ---- Create file selector object for loading ---- */
 fileSelLoad = new FileSelector();

 /* ---- Check for success ---- */
 if (fileSelLoad == static_cast<FileSelector*>(NULL)) exit(EXIT_FAILURE);

 /* ---- Center the file selector to mouse pointer ---- */
 fileSelLoad -> set_position(GTK_WIN_POS_MOUSE);

 /* ---- Set the title ---- */
 fileSelLoad -> set_title("Choose file to load .... ");

 /* ----- Connect "Ok"-Button (load requester) to 'fileLoadOk' ---- */
 (fileSelLoad->get_ok_button())->clicked.connect(SigC::slot(this,&MainWindow::fileOpenOk));

 /* ----- Connect "Cancel"-Button (load requester) to 'fileLoadCancel' ---- */
 (fileSelLoad->get_cancel_button())->clicked.connect(SigC::slot(this,&MainWindow::fileOpenCancel));

 /* ---- Create file selector object for saving ---- */
 fileSelSave = new FileSelector;

 /* ---- Check for success ---- */
 if (fileSelSave == static_cast<FileSelector*>(NULL)) exit(EXIT_FAILURE);

 /* ---- Center the file selector to mouse pointer ---- */
 fileSelSave -> set_position(GTK_WIN_POS_MOUSE);

 /* ---- Set the title ---- */
 fileSelSave -> set_title("Save as .... ");

 /* ----- Connect "Ok"-Button (save requester ) to 'fileSaveOk' ---- */
 (fileSelSave->get_ok_button())->clicked.connect(SigC::slot(this,&MainWindow::fileSaveOk));

 /* ----- Connect "Cancel"-Button (save requester) to 'fileSaveCancel' ---- */
 (fileSelSave->get_cancel_button())->clicked.connect(SigC::slot(this,&MainWindow::fileSaveCancel));

 /* ---- Center the file - selector ---- */
 set_position(GTK_WIN_POS_CENTER);

 /* ---- Create a table object (3x2) ---- */
 table = new Gtk::Table (3,3, true);

 /* ---- Check the creation ---- */
 if (table == (Gtk::Table *) NULL) exit(EXIT_FAILURE);

 /* ---- Set the spacing ---- */
 table -> set_row_spacings(5);
 table -> set_col_spacings(1); 

 /* ---- Set the name of 'table' ---- */
 table -> set_name("table");
 
 /* ---- Create Label - Widget for date information ---- */
 dateLabel = new Gtk::Label();

 /* ---- Check the creation ---- */
 if (dateLabel == (Gtk::Label*) NULL) exit(EXIT_FAILURE); 

 /* ---- Set right justification of text ---- */
 dateLabel -> set_justify(GTK_JUSTIFY_LEFT);

 /* ---- Create alignment for 'dateLabel' (Right aligned) ---- */
 dateLabelA = new Gtk::Alignment(0.0, 0.0, 0.0, 0.0);

 /* ---- Check creation ---- */
 if (dateLabelA == (Gtk::Alignment *) NULL) exit(EXIT_FAILURE);

 /* ---- Create Label - Widget for temperature information ---- */
 tempLabel = new Gtk::Label();

 /* ---- Check the creation ---- */
 if (tempLabel == (Gtk::Label*) NULL) exit(EXIT_FAILURE); 

 /* ---- Set right justification of text ---- */
 tempLabel -> set_justify(GTK_JUSTIFY_LEFT);

 /* ---- Create alignment for tempLabel (Right aligned) ---- */
 tempLabelA = new Gtk::Alignment(0.0, 0.0, 0.0, 0.0);

 /* ---- Check creation ---- */
 if (tempLabelA == (Gtk::Alignment *) NULL) exit(EXIT_FAILURE);

 /* ---- Create Label - Widget for surface interval ---- */
 surfLabel = new Gtk::Label();

 /* ---- Check the creation ---- */
 if (surfLabel == (Gtk::Label*) NULL) exit(EXIT_FAILURE); 

 /* ---- Set right justification of text ---- */
 surfLabel -> set_justify(GTK_JUSTIFY_LEFT);

 /* ---- Create alignment for 'surfLabel' (Right aligned) ---- */
 surfLabelA = new Gtk::Alignment(0.0, 0.0, 0.0, 0.0);

 /* ---- Check creation ---- */
 if (surfLabelA == (Gtk::Alignment *) NULL) exit(EXIT_FAILURE);

 /* ---- Create Label - Widget for start time ---- */
 timeLabel = new Gtk::Label();

 /* ---- Check the creation ---- */
 if (timeLabel == (Gtk::Label*) NULL) exit(EXIT_FAILURE); 

 /* ---- Set right justification of text ---- */
 timeLabel -> set_justify(GTK_JUSTIFY_LEFT);

 /* ---- Create alignment for 'timeLabel' (Right aligned) ---- */
 timeLabelA = new Gtk::Alignment(0.0, 0.0, 0.0, 0.0);

 /* ---- Check creation ---- */
 if (timeLabelA == (Gtk::Alignment *) NULL) exit(EXIT_FAILURE);

 /* ---- Create Label - Widget for start pressure ---- */
 startLabel = new Gtk::Label();

 /* ---- Check the creation ---- */
 if (startLabel == (Gtk::Label*) NULL) exit(EXIT_FAILURE); 

 /* ---- Set right justification of text ---- */
 startLabel -> set_justify(GTK_JUSTIFY_LEFT);

 /* ---- Create alignment for 'startLabel' (Right aligned) ---- */
 startLabelA = new Gtk::Alignment(0.0, 0.0, 0.0, 0.0);

 /* ---- Check creation ---- */
 if (startLabelA == (Gtk::Alignment *) NULL) exit(EXIT_FAILURE);

 /* ---- Create Label - Widget for stop pressure ---- */
 stopLabel = new Gtk::Label();

 /* ---- Check the creation ---- */
 if (stopLabel == (Gtk::Label*) NULL) exit(EXIT_FAILURE); 

 /* ---- Set right justification of text ---- */
 stopLabel -> set_justify(GTK_JUSTIFY_LEFT);

 /* ---- Create alignment for 'stopLabel' (Right aligned) ---- */
 stopLabelA = new Gtk::Alignment(0.0, 0.0, 0.0, 0.0);

 /* ---- Check creation ---- */
 if (stopLabelA == static_cast<Gtk::Alignment *>(NULL)) exit(EXIT_FAILURE);

 /* ---- Create Label - Widget for average depth ---- */
 avgDepthLabel = new Gtk::Label();

 /* ---- Check the creation ---- */
 if (avgDepthLabel == (Gtk::Label*) NULL) exit(EXIT_FAILURE); 

 /* ---- Set right justification of text ---- */
 avgDepthLabel -> set_justify(GTK_JUSTIFY_LEFT);

 /* ---- Create alignment for 'avgDepthLabel' (Right aligned) ---- */
 avgDepthLabelA = new Gtk::Alignment(0.0, 0.0, 0.0, 0.0);

 /* ---- Check creation ---- */
 if (avgDepthLabelA == static_cast<Gtk::Alignment *>(NULL)) exit(EXIT_FAILURE);

 /* ---- Create Label - Widget for maximal depth ---- */
 maxDepthLabel = new Gtk::Label();

 /* ---- Check the creation ---- */
 if (maxDepthLabel == (Gtk::Label*) NULL) exit(EXIT_FAILURE); 

 /* ---- Set right justification of text ---- */
 maxDepthLabel -> set_justify(GTK_JUSTIFY_LEFT);

 /* ---- Create alignment for 'maxDepthLabel' (Right aligned) ---- */
 maxDepthLabelA = new Gtk::Alignment(0.0, 0.0, 0.0, 0.0);

 /* ---- Check creation ---- */
 if (maxDepthLabelA == static_cast<Gtk::Alignment *>(NULL)) exit(EXIT_FAILURE);

 /* ---- Attach labels to their alignment objects  ---- */
 dateLabelA     -> add(*dateLabel);
 tempLabelA     -> add(*tempLabel);
 surfLabelA     -> add(*surfLabel);
 timeLabelA     -> add(*timeLabel);
 startLabelA    -> add(*startLabel);  
 stopLabelA     -> add(*stopLabel);
 avgDepthLabelA -> add(*avgDepthLabel);
 maxDepthLabelA -> add(*maxDepthLabel);

 /* ---- Attach the alignment objects (labels) to table ---- */
 table -> attach(*dateLabelA,     0, 1, 0, 1);
 table -> attach(*tempLabelA,     0, 1, 1, 2);
 table -> attach(*startLabelA,    0, 1, 2, 3);
 table -> attach(*timeLabelA,     1, 2, 0, 1);
 table -> attach(*surfLabelA,     1, 2, 1, 2);
 table -> attach(*stopLabelA,     1, 2, 2, 3);
 table -> attach(*avgDepthLabelA, 2, 3, 0, 1);
 table -> attach(*maxDepthLabelA, 2, 3, 1, 2);

 /* ---- Create the 'diveFrame' ---- */ 
 diveFrame = new Gtk::Frame(" Dive Information  ");

 /* ---- Check the creation ---- */
 if (diveFrame == static_cast<Gtk::Frame*>(NULL)) exit(EXIT_FAILURE);

 /* ---- Set of frames ---- */
 diveFrame -> set_label_align(0.0, 1.0);

 /* ---- Attach 'table' to 'diveFrame' ---- */
 diveFrame -> add(*table);

 /* ---- Create a status-line ---- */
 statusText = new Gtk::Entry();

 /* ---- Check the creation of status-line ---- */
 if (statusText == static_cast<Gtk::Entry *>(NULL)) exit(EXIT_FAILURE);

 /* ---- Status line is not editable ---- */
 statusText -> set_editable(false);

 /* ---- Create a drawing area ---- */
 area = new UCS();

 /* ---- Check the creation ---- */
 if (area == static_cast<UCS*>(NULL)) exit(EXIT_FAILURE);

 /* ---- Set the size ---- */
 area -> size(480, 320);

 /* ---- Set the name ---- */
 area -> set_name("plotarea");

 /* ---- Set key - callback ---- */
 add_events(GDK_KEY_RELEASE_MASK);
 key_press_event.connect(SigC::slot(this, &MainWindow::handleKey));

 /* ---- Pack all into 'vbox' ---- */ 
 vbox -> pack_start(*area, TRUE, TRUE, 0);
 vbox -> pack_start(*diveFrame, FALSE, FALSE, 0);
 vbox -> pack_start(*statusText, FALSE, FALSE, 0);

 /* ---- Show all widget's ---- */
 show_all();

 /* ---- Create a requester with one button ---- */ 
 oneButReq = new SimpleRequest("One-Button Request", false);

 /* ---- Check creation ---- */
 if (oneButReq == static_cast<SimpleRequest*>(NULL)) exit(EXIT_FAILURE);

 /* ---- Create a request with two buttons ----- */
 twoButReq = new SimpleRequest("Two-Button Request", true);

 /* ---- Check the creation ---- */
 if (twoButReq == static_cast<SimpleRequest*>(NULL)) exit(EXIT_FAILURE);

}

MainWindow::~MainWindow()
{
#ifndef NDEBUG
 cerr << "Destroy MainWindow" << endl;
#endif

 /* ---- Delete VBox on top ---- */
 vbox -> hide();
 vbox -> destroy();
 delete vbox;

 /* ---- Free all labels and alignment objects ---- */
 maxDepthLabel  -> destroy(); maxDepthLabelA  -> destroy(); 
 avgDepthLabel  -> destroy(); avgDepthLabelA  -> destroy(); 
 stopLabel  -> destroy();     stopLabelA  -> destroy(); 
 startLabel -> destroy();     startLabelA -> destroy();
 timeLabel  -> destroy();     timeLabelA  -> destroy();
 surfLabel  -> destroy();     surfLabelA  -> destroy();
 tempLabel  -> destroy();     tempLabelA  -> destroy();
 dateLabel  -> destroy();     dateLabelA  -> destroy();
 diveFrame  -> destroy();
 delete maxDepthLabel; delete maxDepthLabelA;
 delete avgDepthLabel; delete avgDepthLabelA;
 delete stopLabel;     delete stopLabelA;
 delete startLabel;    delete startLabelA;
 delete timeLabel;     delete timeLabelA;
 delete surfLabel;     delete surfLabelA;
 delete tempLabel;     delete tempLabelA;
 delete dateLabel;     delete dateLabelA;
 delete diveFrame;     delete statusText;

 /* ---- Delete the table widget used for dive information ---- */
 table -> hide(); table -> destroy(); delete table;

 /* ---- Free the UCS widget ('area') and frame ---- */
 area -> hide(); area -> destroy(); delete area;

 /* ---- Free the file selectors ---- */
 fileSelLoad -> destroy(); delete fileSelLoad;
 fileSelSave -> destroy(); delete fileSelSave;

 /* ---- Delete the requester ---- */
 oneButReq -> hide(); oneButReq -> destroy(); delete oneButReq;
 twoButReq -> hide(); twoButReq -> destroy(); delete twoButReq;

 /* ---- Check for already loaded profile data  ---- */
 if (haveValidProfile) {

#ifndef NDEBUG
  cerr << "Free old profile" << endl;
#endif

  /* ---- Free it and init pointer ---- */
  UDCFFree(profile);
  profile = static_cast<UDCF *>(NULL);

 }

 /* ---- Check if the is a dive pointer left and free it if needed ---- */
 if (dive != static_cast<UDCFDive*>(NULL)) UDCFFreeDive(dive);

#ifndef NDEBUG
 cerr << "End of destroy MainWindow" << endl;
#endif

}

void MainWindow::ProcessSampleInfo(const UDCFSample* sample)
{
 const int MsgBufferLen = 1025;
 char msgBuffer[MsgBufferLen + 1];

 /* ---- Check for a valid sample and a valid profile ---- */
 if ((sample == static_cast<UDCFSample*>(NULL)) || (!haveValidProfile))  return;

 /* ---- Clear message region ---- */
 setStatusLine("");

 /* ---- Check the sample-type ---- */
 switch (sample -> type) {

  /* ---- Found a alarm marker ---- */
  case ST_MARK:

   /* ---- Check for marker type ---- */
   switch (sample -> data.mark) {

    case C_SURF: 
   
     setStatusLine("Surface reached");
     break;

    case C_ASC:
 
     setStatusLine("Ascent speed exceeded");
     break;

    case C_DECO:

     setStatusLine("Decompression needed");
     break;

    case C_BREATH:
  
     setStatusLine("Out of breath warning");
     break;

    case C_RBT:
 
     setStatusLine("No bottom time left");
     break;  

    case C_ERROR:
 
     setStatusLine("General error - Missed decompression");
     break;  

    default:
     setStatusLine("Unknown marker type found!");

   }
   break;

  /* ---- Found a sample-temperature ---- */
  case ST_TEMPERATURE:

   /* ---- Check for the used units ---- */
   if (profile -> measure == metric) {

    /* ---- Write the temperature to the status-line (Celsius) ---- */
    snprintf(msgBuffer, 
             MsgBufferLen - 1, 
             "Temperature: %6.2f C", 
              profile -> groupList[actGroup].diveList[actDive].temperature);

   } else {

    /* ---- Write the temperature to the status-line (Fahrenheit) ---- */
    snprintf(msgBuffer, 
             MsgBufferLen - 1, 
             "Temperature: %6.2f F", 
              profile -> groupList[actGroup].diveList[actDive].temperature);

   }
   /* ---- Show the mix information ----- */
   setStatusLine(msgBuffer);
   break;

  /* ---- Found a mix change ---- */
  case ST_MIX:
  
   /* ---- Check for valid range ---- */
   if ((sample -> data.mix >= 0) && 
       (sample -> data.mix <= profile -> groupList[actGroup].
                                         diveList[actDive].
	                                 mixIndex)) {
 
    /* ---- Add name of mix to the  message ---- */
    snprintf(msgBuffer, 
             MsgBufferLen - 1, 
             "Switched to mix `%s'", 
             profile -> groupList[actGroup].
                        diveList[actDive].
                        mixList[sample -> data.mix].mixName);

   } else {

    /* ---- Give an error ---- */
    snprintf(msgBuffer, 
             MsgBufferLen - 1, 
             "Unknown mix having index %ld",
             sample -> data.mix);

   }

   /* ---- Show the mix information ----- */
   setStatusLine(msgBuffer);
   break;

  case ST_SAMPLETIME:
   
   /* ---- Make text for sampletime-marker ---- */
   snprintf(msgBuffer,
            MsgBufferLen - 1,
            "Set sampletime to %5.2f sec",
            sample -> data.sampleTime);

   /* ---- Show the sample-time information ---- */
   setStatusLine(msgBuffer);
   break;

  case ST_WORK:
   
   /* ---- Make text for sampletime-marker ---- */
   snprintf(msgBuffer,
            MsgBufferLen - 1,
            "Workload is %5.2f",
            sample -> data.work);

   /* ---- Show the workload information ---- */
   setStatusLine(msgBuffer);
   break;

  /* ---- Ignore this sample-type ---- */
  case ST_DEPTH:
  case ST_TD:
   break;

  default:
   
   /* ---- Set to unknown sample time ---- */
   setStatusLine("Found unknown sample type!");
   break;

 }

}

void MainWindow::makeMenu()
{
 using namespace Gtk::Menu_Helpers;

 /* ---- Create the menubar ---- */
 menuBar = new Gtk::MenuBar();

 /* ---- Check the creation and manage it ---- */
 if (menuBar == static_cast<Gtk::MenuBar *>(NULL)) exit(EXIT_FAILURE);
 manage(menuBar);

 /* ---- Create file - menu ---- */
 fileMenu = new Gtk::Menu();

 /* ---- Check the creation and manage the file-menu ---- */
 if (fileMenu == static_cast<Gtk::Menu *>(NULL)) exit(EXIT_FAILURE);
 manage(fileMenu);
 
 /* ---- Get the list of entries of file menu ---- */
 MenuList& fileList = fileMenu -> items();

 /* ---- Add the entries to file-menu ---- */
 fileList.push_back(MenuElem("_Open", "<control>o", slot(this, &MainWindow::fileOpen)));
 fileList.push_back(MenuElem("_Save", "<control>s", slot(this, &MainWindow::fileSave)));
 fileList.push_back(SeparatorElem());
 fileList.push_back(MenuElem("_Quit", "<control>q", slot(this, &MainWindow::quitIt)));

 /* ---- Create dive - menu ---- */
 diveMenu = new Gtk::Menu();

 /* ---- Check the creation and manage the file-menu ---- */
 if (diveMenu == static_cast<Gtk::Menu *>(NULL)) exit(EXIT_FAILURE);
 manage(diveMenu);
 
 /* ---- Get the list of entries of file menu ---- */
 MenuList& diveList = diveMenu -> items();

 /* ---- Create entries of dive - menu ---- */
 diveList.push_back(MenuElem("Next", "n", slot(this, &MainWindow::nextDive)));
 diveList.push_back(MenuElem("Previous", "p", slot(this, &MainWindow::previousDive)));
 diveList.push_back(SeparatorElem());
 diveList.push_back(MenuElem("Next Group", "e", slot(this, &MainWindow::nextGroup)));
 diveList.push_back(MenuElem("Previous Group", "r", slot(this, &MainWindow::previousGroup)));

 /* ---- Create help - menu ---- */
 helpMenu = new Gtk::Menu();

 /* ---- Check the creation and manage the file-menu ---- */
 if (helpMenu == static_cast<Gtk::Menu *>(NULL)) exit(EXIT_FAILURE);
 manage(helpMenu);
 
 /* ---- Get the list of entries of file menu ---- */
 MenuList& helpList = helpMenu -> items();

 /* ---- Create entries of dive - menu ---- */
 helpList.push_back(MenuElem("_About", "<control>a", slot(this, &MainWindow::about)));

 /* ---- Add all menus to the menubar ---- */
 MenuList& barList = menuBar -> items();
 barList.push_front(MenuElem("_Help", "<control>h", *helpMenu));
 barList.front() -> right_justify();
 barList.push_front(MenuElem("_Dive", "<control>d", *diveMenu));
 barList.push_front(MenuElem("_File", "<control>f", *fileMenu));

 /* ---- Add the menu to the vbox ---- */
 vbox -> pack_start(*menuBar, false, false);

}

gint MainWindow::delete_event_impl(GdkEventAny *) 
{
#ifndef NDEBUG
 cerr << "Handle delete event" << endl;
#endif

 /* ---- Delete the window ---- */
 Gtk::Main::quit();
 return 0;

}

void MainWindow::showInfos(UDCFDive* dive)
{
 ostrstream dateVal;
 double diveTime = static_cast<double>(0.0);
 double avgDepth = static_cast<double>(0.0);
 double maxDepth = static_cast<double>(0.0);

 /* ---- Format the date info (Terminate string with char(0)!) ---- */
 dateVal << "Date: ";  
 dateVal.width(2);
 dateVal.fill('0');
 dateVal << profile -> groupList[actGroup].diveList[actDive].day
         << "/";
 dateVal.width(2);
 dateVal.fill('0');
 dateVal << profile -> groupList[actGroup].diveList[actDive].month
         << "/"
         << profile -> groupList[actGroup].diveList[actDive].year
         << ends; 

 /* ---- Set the date label ---- */
 dateLabel -> set_text(dateVal.str());

 /* ---- StrStreams for temp, start pressure, stop pressure, etc ---- */
 ostrstream tempVal; ostrstream surfVal;
 ostrstream startVal; ostrstream stopVal;
 ostrstream avgDepthVal; ostrstream maxDepthVal;
 ostrstream frameLabelVal;

 /* ---- Calculate new frame label and set it ---- */
 frameLabelVal << " Dive Information:  " 
               << "(Group No. "
               << actGroup
               << " / Dive No. "
               << actDive
               << ")"
               << ends;
 diveFrame -> set_label(frameLabelVal.str());

 /* ---- Calculate some informations about the actual dive ---- */
 avgDepth = UDCFAverageDepth(&(profile -> groupList[actGroup].diveList[actDive]));
 UDCFGetDiveData(&(profile -> groupList[actGroup].diveList[actDive]), 
                 &diveTime, 
                 &maxDepth);

 /* ---- Check for metric/imperial ---- */
 if (profile -> measure == metric) {

  /* ---- Metric temperature ---- */
  tempVal << "Temperature: "
          << profile -> groupList[actGroup].diveList[actDive].temperature
          << " C"
          << ends;

  /* ---- Calculate label for average depth ---- */
  avgDepthVal.setf(ios::fixed, ios::floatfield);
  avgDepthVal.precision(2);
  avgDepthVal << "Average Depth: "
              << avgDepth 
              << " m"
              << ends;

  /* ---- Calculate label for max depth ---- */
  maxDepthVal.setf(ios::fixed, ios::floatfield);
  maxDepthVal.precision(2);
  maxDepthVal << "Maximum Depth: "
              << maxDepth 
              << " m"
              << ends;

  /* ---- Check if there are valid mixes ---- */
  if ((dive -> mixList != static_cast<UDCFMix *>(NULL)) &&
      (dive -> mixList[0].pressureStart != C_DIVE_INVALID) &&
      (dive -> mixList[0].pressureEnd != C_DIVE_INVALID)) {

   /* ---- Metric pressures ---- */
   startVal << "Start Pressure: " 
            << dive -> mixList[0].pressureStart / 100000
            << " Bar" 
            << '\0';
   stopVal << "End Pressure: " 
           << dive -> mixList[0].pressureEnd / 100000
           << " Bar" 
           << ends;

  } else {

   /* ---- Unknown values ---- */
   startVal << "Start Pressure: Unknown" << ends;
   stopVal  << "End Pressure: Unknown" << ends;

  }

 } else {

  /* ---- Imperial temperature ---- */
  tempVal << "Temperature: "
          << profile -> groupList[actGroup].diveList[actDive].temperature
          << " F"
          << '\0';

  /* ---- Calculate label for max depth ---- */
  maxDepthVal.setf(ios::fixed, ios::floatfield);
  maxDepthVal.precision(2);
  maxDepthVal << "Maximum Depth: "
              << maxDepth
              << " ft"
              << ends;

  /* ---- Calculate label for average depth ---- */
  avgDepthVal.setf(ios::fixed, ios::floatfield);
  avgDepthVal.precision(2);
  avgDepthVal << "Average Depth: "
              << avgDepth 
              << " ft"
              << ends;

  /* ---- Check if there are valid mixes ---- */
  if ((dive -> mixList != static_cast<UDCFMix *>(NULL)) &&
      (dive -> mixList[0].pressureStart != C_DIVE_INVALID) &&
      (dive -> mixList[0].pressureEnd != C_DIVE_INVALID)) {

 

   /* ---- Imperial pressures ---- */
   startVal << "Start Pressure: " 
            << dive -> mixList[0].pressureStart
            << " PSI" 
            << '\0';
   stopVal << "End Pressure: " 
           << dive -> mixList[0].pressureEnd
           << " PSI" 
           << ends;

  } else {

   /* ---- Unknown values ---- */
   startVal << "Start Pressure: Unknown" << ends;
   stopVal  << "End Pressure: Unknown" << ends;

  }

 }

 /* ---- Set the temperature, pressure labels etc ---- */
 tempLabel -> set_text(tempVal.str());
 startLabel -> set_text(startVal.str());
 stopLabel -> set_text(stopVal.str());
 avgDepthLabel -> set_text(avgDepthVal.str());
 maxDepthLabel -> set_text(maxDepthVal.str());

 /* ---- Check for an valid surface interval ---- */
 if (profile -> 
      groupList[actGroup].diveList[actDive].surfaceInterval !=  C_NAI) {

  /* ---- Check for surface - interval longer than 1 hour ---- */
  if (profile -> 
      groupList[actGroup].diveList[actDive].surfaceInterval >= 60) {

   long hour, min;
 
   /* ---- Calc hours and minutes ---- */
   hour = static_cast<long>(floor(profile -> 
                            groupList[actGroup].diveList[actDive].surfaceInterval / 60));
   min =  static_cast<long>(floor(profile -> 
                            groupList[actGroup].diveList[actDive].surfaceInterval -
                            60 * hour));

   /* ---- Calc surface interval information ---- */
   surfVal << "Surface: "
           << hour
           << ":";
   surfVal.width(2);
   surfVal.fill('0');
   surfVal << min  
           << ends;

  } else {

   /* ---- Calc surface interval information ---- */
   surfVal << "Surface: "
           << profile -> 
               groupList[actGroup].diveList[actDive].surfaceInterval
           << " min" 
           << ends;

  }

 } else {

  /* ---- Calc label for infinitiy time interval ---- */
  surfVal << "Surface: infinity"
          << ends;

 }

 /* ---- Set the label of 'surfLabel' ---- */
 surfLabel -> set_text(surfVal.str());

 /* ---- Create string for time of start of dive ---- */
 ostrstream timeVal;
 timeVal << "Time: "
         << profile -> groupList[actGroup].diveList[actDive].hour
         << ":";
 timeVal.width(2);
 timeVal.fill('0');
 timeVal << profile -> groupList[actGroup].diveList[actDive].minute
         << ends;

 /* ---- Set the start time label ---- */
 timeLabel -> set_text(timeVal.str());

}

void MainWindow::displayDive()
{
 UCS::profile curve;

 /* ---- Check if we have an valid profile ---- */
 if (!haveValidProfile) return;

#ifndef NDEBUG
 cerr << "DisplayDive" << endl;
#endif

 /* ---- Check if the is an old dive pointer left and free it if needed ---- */
 if (dive != static_cast<UDCFDive*>(NULL)) UDCFFreeDive(dive);
 dive = static_cast<UDCFDive*>(NULL);

 /* ---- Convert the dive to XY-Mode (And make a copy) ---- */
 dive = UDCFConvertDelta2TD(&profile -> groupList[actGroup].diveList[actDive]);

 /* ---- Show all infos of this dive ---- */
 showInfos(dive);

 /* ---- Show the diving place in title (if available) ---- */
 if (dive -> place != (char *) NULL) 
  set_title(dive -> place);
 else
  set_title(fileSelLoad -> get_filename());

 /* ---- Resize the vector 'curve' for all samples in 'dive' ---- */
 curve.resize(dive -> sampleIndex + 1);

 /* ---- Copy all samples ---- */
 for (long i = 0; i <= dive -> sampleIndex; ++i) curve[i] = dive -> sampleList[i];

 /* ---- Assign curve and fully redraw drawing area widget ---- */
 (void) area -> setData(curve);
 area -> redraw();

}

void MainWindow::nextGroup()
{
 /* ---- Check for a valid profile ---- */
 if (!haveValidProfile) return;

 /* ---- Calc the next group ---- */
 actGroup++; 
 actGroup %= ((profile -> groupIndex) + 1);

 /* ---- Set the marker to invisible ---- */
 area -> SetMarkerState(false);

 /* ---- Restart at first dive ---- */
 actDive = 0;

#ifndef NDEBUG
 cerr << "Goto Group " << actGroup << endl;
#endif

 /* ---- Display the dive ---- */
 displayDive();

 /* ---- Give information about sample on status line ---- */
 if (area -> GetMarkerState()) ProcessSampleInfo(area -> GetMarkerSample());


}

void MainWindow::previousGroup()
{
 /* ---- Check for a valid profile ---- */
 if (!haveValidProfile) return;

 /* ---- Calc previous group (Note: x - 1 mod n = x + (n - 1) mod n) ---- */
 actGroup += profile -> groupIndex; 
 actGroup %= ((profile -> groupIndex) + 1);

 /* ---- Set the marker to invisible ---- */
 area -> SetMarkerState(false);

 /* ---- Restart at first dive ---- */
 actDive = 0;

#ifndef NDEBUG
 cerr << "Goto Group " << actGroup << endl;
#endif

 /* ---- Display the dive ---- */
 displayDive();

 /* ---- Give information about sample on status line ---- */
 if (area -> GetMarkerState()) ProcessSampleInfo(area -> GetMarkerSample());

}

void MainWindow::nextDive()
{
 /* ---- Check for a valid profile ---- */
 if (!haveValidProfile) return;

 /* ---- Calc next dive ---- */
 actDive++;
 actDive %= (profile -> groupList[actGroup].diveIndex + 1);

 /* ---- Set the marker to invisible ---- */
 area -> SetMarkerState(false);
 
#ifndef NDEBUG
 cerr << "Goto Dive " << actDive << endl;
#endif

 /* ---- Display the dive ---- */
 displayDive();

 /* ---- Give information about sample on status line ---- */
 if (area -> GetMarkerState()) ProcessSampleInfo(area -> GetMarkerSample());

}

void MainWindow::previousDive()
{
 /* ---- Check for a valid profile ---- */
 if (!haveValidProfile) return;

 /* ---- Calc next dive (Note: x - 1 mod n = x + (n - 1) mod n) ---- */
 actDive += profile -> groupList[actGroup].diveIndex;
 actDive %= (profile -> groupList[actGroup].diveIndex + 1);

 /* ---- Set the marker to invisible ---- */
 area -> SetMarkerState(false);

#ifndef NDEBUG 
 cerr << "Goto Dive " << actDive << endl;
#endif

 /* ---- Display the dive ---- */
 displayDive();

 /* ---- Give information about sample on status line ---- */
 if (area -> GetMarkerState()) ProcessSampleInfo(area -> GetMarkerSample());

}

void MainWindow::setStatusLine(const char* info)
{
 /* ---- Set the text ---- */
 statusText -> set_text(info);

#ifndef NDEBUG 
 cerr << "Set status line " << endl;
#endif

}

void MainWindow::fileOpen()
{

 /* ---- Show the file selector ----- */
 fileSelLoad -> show();

#ifdef NDEBUG
 /* ---- Make it modal ----- */
 fileSelLoad -> set_modal(true);
#endif

}

void MainWindow::fileOpenOk()
{
#ifndef NDEBUG
 cerr << "Pressed OK - Button of load requester:" 
      << fileSelLoad -> get_filename() 
      << endl;
#endif

 UDCF* tmpProfile = static_cast<UDCF *>(NULL);

#ifdef NDEBUG
 /* ---- Make it un-modal ----- */
 fileSelLoad -> set_modal(false);
#endif

 /* ---- Hide the filerequester ----- */
 fileSelLoad -> hide();

 /* ---- Open selected file using C calls ---- */
 FILE* proFileHandle = fopen(fileSelLoad -> get_filename().c_str(), "r");

 /* ---- Check if file was opened ---- */
 if (proFileHandle == static_cast<FILE *>(NULL)) {

  ostrstream msg;

  /* ---- Create a error message ---- */
  msg << " Can't open `"
      << fileSelLoad -> get_filename()
      << "' "
      << endl
      << " (" 
      << strerror(errno)
      << ") "
      << ends;
  oneButReq -> set_title("Warning .... ");
  oneButReq -> setText(msg.str());

  /* ---- Open the request (Don't terminate on "ok") ---- */
  oneButReq -> ask(false);
 
  /* ---- After the request has been closed return ---- */
  return;

 }

 /* ---- Get information of the file ---- */
 struct stat statBuf;
 int statRes = stat(fileSelLoad -> get_filename().c_str(), &statBuf); 

 /* ---- Check if this was successful ---- */
 if (statRes != 0) {

  ostrstream msg;

  /* ---- Create a error message ---- */
  msg << " Can't get information of `"
      << fileSelLoad -> get_filename()
      << "' "
      << endl
      << " (" 
      << strerror(errno)
      << ") "
      << ends;
  oneButReq -> set_title("Warning .... ");
  oneButReq -> setText(msg.str());

  /* ---- Open the request (Don't terminate on "ok") ---- */
  oneButReq -> ask(false);
 
  /* ---- Close the file ---- */
  fclose(proFileHandle);

  /* ---- After the request has been closed return ---- */
  return;

 }

 /* ---- Check if this file is a regular file ---- */ 
 if (!S_ISREG(statBuf.st_mode)) {

  ostrstream msg;

  /* ---- Create a error message ---- */
  msg << " `"
      << fileSelLoad -> get_filename()
      << "' isn't a profile "
      << ends;
  oneButReq -> set_title("Warning .... ");
  oneButReq -> setText(msg.str());

  /* ---- Open the request (Don't terminate on "ok") ---- */
  oneButReq -> ask(false);
 
  /* ---- Close the file ---- */
  fclose(proFileHandle);

  /* ---- After the request has been closed return ---- */
  return;

 } 

 /* ---- Load the profile ---- */
 tmpProfile = UDCFRead(proFileHandle);

 /* ---- Close the file ---- */
 fclose(proFileHandle);

 /* ---- Check the success of "loading profile" ---- */
 if (tmpProfile != static_cast<UDCF *>(NULL)) {
 
  /* ---- Check for already loaded profile data  ---- */
  if (profile != static_cast<UDCF *>(NULL)) {

#ifndef NDEBUG
   cerr << "Free old profile" << endl;
#endif

   /* ---- Free it and init pointer ---- */
   UDCFFree(profile);
   profile = (UDCF *) NULL;

  }

  /* ---- Set the marker to invisible ---- */
  area -> SetMarkerState(false);

  /* ---- Activate the loaded profile ---- */
  profile = tmpProfile;

  /* ---- Now we have a valid profile in memory ---- */
  haveValidProfile = true;

  /* ---- Set the window title ---- */
  set_title(fileSelLoad -> get_filename());

  /* ---- Set the metric/imperial mode of 'area' ---- */
  if (tmpProfile -> measure == metric)
   area -> setMetric(true);
  else
   area -> setMetric(false);

 } else {

  ostrstream msg;

  /* ---- Create the error message ---- */
  msg << " Can't parse file `" 
      << fileSelLoad -> get_filename() 
      << "' " 
      << endl
      << "(Error in line "
      << errorLine 
      << ") "
      << ends;
  oneButReq -> set_title("Warning .... ");
  oneButReq -> setText(msg.str());

  /* ---- Open the request (Don't terminate on "ok") ---- */
  oneButReq -> ask(false);

 }

 /* ---- Display 1st dive of 1st repgroup ---- */
 actGroup = 0; actDive = 0;
 displayDive();

 /* ---- Give information about sample on status line ---- */
 if (area -> GetMarkerState()) ProcessSampleInfo(area -> GetMarkerSample());

}

void MainWindow::fileOpenCancel()
{
#ifndef NDEBUG
 cerr << "Pressed Cancel-Button of load requester" << endl;
#endif

 /* ---- Hide it ----- */
 fileSelLoad -> hide();

#ifdef NDEBUG
 /* ---- Make it un-modal ----- */
 fileSelLoad -> set_modal(false);
#endif

}


void MainWindow::fileSave()
{
 /* ---- Show the file selector ----- */
 fileSelSave -> show();

#ifdef NDEBUG
 /* ---- Make it modal ----- */
 fileSelSave -> set_modal(true);
#endif

}
void MainWindow::fileSaveOk()
{
#ifndef NDEBUG
 cerr << "Pressed OK - Button of save requester:" 
      << fileSelLoad -> get_filename() 
      << endl;
#endif

 /* ---- Hide it ----- */
 fileSelSave -> hide();

#ifdef NDEBUG
 /* ---- Make it un-modal ----- */
 fileSelSave -> set_modal(false);
#endif

 /* ---- Check for a valid profile to save ---- */
 if  (profile == static_cast<UDCF*>(0)) {

  ostrstream msg;

  /* ---- Create a error message ---- */
  msg << " Can't save as `"
      << fileSelSave -> get_filename()
      << "' "
      << endl
      << " No valid profile active "
      << ends;

  oneButReq -> set_title("Warning .... ");
  oneButReq -> setText(msg.str());

  /* ---- Open the request (Don't terminate on "ok") ---- */
  oneButReq -> ask(false);

  /* ---- Simply return and do nothing ---- */ 
  return;

 }

 /* ---- Open the file ---- */
 FILE* proFileHandle = fopen(fileSelSave -> get_filename().c_str(), "w");

 if (proFileHandle == static_cast<FILE *>(NULL)) {

  ostrstream msg;

  /* ---- Create an error message ---- */
  msg << " Can't save as `"
      << fileSelSave -> get_filename()
      << "' "
      << endl
      << " (" 
      << strerror(errno)
      << ") "
      << ends;
  oneButReq -> set_title("Warning .... ");
  oneButReq -> setText(msg.str());

  /* ---- Open the request (Don't terminate on "ok") ---- */
  oneButReq -> ask(false);
 
  /* ---- After the request has been closed return ---- */
  return;

 }

 if (!UDCFWrite(proFileHandle, profile)) {

  ostrstream msg;

  /* ---- Create an error message ---- */
  msg << " Error while writing to `"
      << fileSelSave -> get_filename()
      << "' "
      << endl
      << " (" 
      << strerror(errno)
      << ") "
      << ends;
  oneButReq -> set_title("Warning .... ");
  oneButReq -> setText(msg.str());

  /* ---- Open the request (Don't terminate on "ok") ---- */
  oneButReq -> ask(false);
 
 }

 /* ---- Close the file ---- */
 fclose(proFileHandle);

}

void MainWindow::fileSaveCancel()
{
#ifndef NDEBUG
 cerr << "Pressed Cancel-Button of save requester" << endl;
#endif

 /* ---- Hide it ----- */
 fileSelSave -> hide();

#ifdef NDEBUG
 /* ---- Make it un-modal ----- */
 fileSelSave -> set_modal(false);
#endif

}
void MainWindow::quitIt()
{
 ostrstream msg;

#ifndef NDEBUG
 cerr << "Quit the program" << endl;
#endif

 /* ---- Create the error message ---- */
 msg << " Do you really want to quit ? " 
     << ends;
 twoButReq -> set_title("Question .... ");
 twoButReq -> setText(msg.str());

 /* ---- Open the request (Terminate on "ok") ---- */
 twoButReq -> ask(true);

}

void MainWindow::about()
{
 const int bufferLen = 128;
 string msg;
 char gversion[bufferLen + 1];
 char gmversion[bufferLen + 1];

 /* ---- Don't include gtk--.h! It includes a lot of unneeded header-files ---- */
 extern const guint gtkmm_major_version;
 extern const guint gtkmm_minor_version;
 extern const guint gtkmm_micro_version;

 /* ---- Make gtk/gtkmm version string ---- */
 snprintf(gversion, 
          bufferLen - 1, 
          "v%d.%d.%d",
          gtk_major_version,
          gtk_minor_version,
          gtk_micro_version);
 snprintf(gmversion, 
          bufferLen - 1, 
          "v%d.%d.%d",
          gtkmm_major_version,
          gtkmm_minor_version,
          gtkmm_micro_version);
                                               
 /* ---- Build the about text ---- */
 msg = " Universal Dive Computer Format - Profile viewer \n";
 msg += " Version ";
 msg += VERSION;
 msg += " (Gtk: ";
 msg += gversion;
 msg += " / Gtk--: ";
 msg += gmversion;
 msg += ")";
 msg += " \n\n(c) 1999, 2000, 2001 and 2002 by Steffen Reith\n";
 msg += "streit@kurgan.mayn.de";

 /* ---- Set the title and the message ---- */
 oneButReq -> set_title("About .... ");
 oneButReq -> setText(msg);

 /* ---- Show the requester ----- */
 oneButReq -> ask(false);

}

gint MainWindow::handleKey(GdkEventKey *event)
{
 /* ---- Check for Cursor-Keys (ignore all other key-events)  ---- */
 if (event -> keyval == GDK_Left) {

  /* ---- Move the marker one sample left ---- */
  area -> MoveMarkerLeft();

  /* ---- Give information about sample on status line ---- */
  if (area -> GetMarkerState()) ProcessSampleInfo(area -> GetMarkerSample());

 } else if (event -> keyval == GDK_Right) {

  /* ---- Move the marker one sample right ---- */
  area -> MoveMarkerRight();
  
  /* ---- Give information about sample on status line ---- */
  if (area -> GetMarkerState()) ProcessSampleInfo(area -> GetMarkerSample());
 
 } else if (event -> keyval == GDK_Escape) {

  /* ---- Toggle visibility of marker ---- */
  area -> SetMarkerState(!area -> GetMarkerState());

  /* ---- Check for visible marker ----- */
  if (area -> GetMarkerState()) 

   /* ---- Renew status line ---- */
   ProcessSampleInfo(area -> GetMarkerSample());

  else 

   /* ---- Erase status-line ---- */
   setStatusLine("");

 }

 /* ---- Event was handled ---- */
 return 0;

}
