//-*-C++-*-  
#include <SimpleRequest.h>

#include <gtk--/button.h>
#include <gtk--/main.h>

#ifdef WITH_DMALLOC 
#include<dmalloc.h>
#endif

SimpleRequest::SimpleRequest(const string &text, 
                             bool haveCancelButt) 
              : Gtk::Window(GTK_WINDOW_DIALOG),
                label(text)
{
 /* ---- Equal size for all entries of 'actionArea' ---- */
 actionArea.set_homogeneous(true);

 /* ---- Center the requester to mouse pointer ---- */
 set_position(GTK_WIN_POS_MOUSE);

 /* ---- Add the boxes to the window ---- */
 add(vbox); 

 /* ---- Add 'label' to 'vbox' of dialog ---- */
 vbox.pack_start(label, true, true, 10);

 /* ---- Add the 'actionArea' to the end of 'vbox' ---- */
 vbox.pack_end(actionArea, false, false, 10);
 
 /* ---- Set the the title ---- */
 this -> set_title("Information....");

 /* ---- Create OK-Button ---- */
 okButton = new Gtk::Button("Ok");

 /* ---- Check the creation ---- */
 if (okButton == static_cast<Gtk::Button *>(NULL)) {

  /* ---- Write the error - text on stderr ---- */
  cerr << "Can't allocate ok-button!" << endl << text << endl;

 }

 /* ---- Set name of ok-button ---- */
 if (haveCancelButt) 
  okButton -> set_name("ok button2");
 else 
  okButton -> set_name("ok button1");

 /* ----- Pack the ok-button ---- */
 actionArea.pack_start(*okButton, true, true, 10);

 /* ---- Check if we need a cancel - button ---- */
 if (haveCancelButt) {

  /* ---- Create cancel-Button ---- */
  cancelButton = new Gtk::Button("Cancel");

  /* ---- Check the creation ---- */
  if (cancelButton == static_cast<Gtk::Button *>(NULL)) {

   /* ---- Write the error - text on stderr ---- */
   cerr << "Can't allocate cancel-button!" << endl << text << endl;

  }

  /* ---- Set name of cancel-button ---- */
  cancelButton -> set_name("cancel button"); 

  /* ---- Pack the cancel-button a the end of the action area ---- */
  actionArea.pack_end(*cancelButton, true, true, 10);

  /* ---- Show the cancel - button if the request is showed ---- */
  cancelButton -> show();

  /* ---- Connect to cancel callback ----- */
  cancelButton -> clicked.connect(SigC::slot(this, &SimpleRequest::cancelCallback));

 } else {

  /* ---- Init the pointer to cancel button ---- */
  cancelButton = static_cast<Gtk::Button *>(NULL);

 }

 /* ---- Show ok-button/label (But not the simple-request window) ---- */
 vbox.show();
 actionArea.show();
 okButton -> show();
 label.show();

 /* ---- Set the callback for ok button ---- */
 okButton->clicked.connect(SigC::slot(this,&SimpleRequest::okCallback));

}

SimpleRequest::~SimpleRequest()
{
 
#ifndef NDEBUG
 cerr << "Destroy SimpleRequest" << endl;
#endif

 /* ---- Hide all widgets inside SimpleRequest ---- */
 label.hide();
 okButton -> hide();
 if (cancelButton != static_cast<Gtk::Button *>(NULL)) cancelButton -> hide();
 actionArea.hide();
 vbox.hide();

 /* ----- Free the dynamic allocated widgets ---- */
 okButton -> destroy(); delete okButton;
 if (cancelButton != static_cast<Gtk::Button *>(NULL)){

  /* ---- Delete it ---- */
  cancelButton -> destroy();
  delete cancelButton;

 }

#ifndef NDEBUG
 cerr << "End of Destroy SimpleRequest" << endl;
#endif

}

void SimpleRequest::setText(const string &text)
{
 /* ---- Set the new text of label-widget ---- */
 label.set_text(text); 

}

void SimpleRequest::ask(bool terminate)
{
 /* ---- Store the terminate flag ---- */
 termFlag = terminate;

#ifdef NDEBUG
 /* ---- Make this requester modal ---- */
 set_modal(true);
#endif

 /* ---- Show the requester ----- */
 this -> show();

}

void SimpleRequest::okCallback()
{
 /* ---- Hide the requester ----- */
 this -> hide();

#ifdef NDEBUG
 /* ---- Remove modality ---- */
 set_modal(false);
#endif

 /* ---- Check if we have to terminate ---- */
 if (termFlag) {

  /* ---- Give a message and quit ---- */
  cerr << "Bye.." << endl;
  Gtk::Main::quit();

 }

}

void SimpleRequest::cancelCallback()
{
 /* ---- Hide the requester ----- */
 this -> hide();

#ifdef NDEBUG
 /* ---- Remove modality ---- */
 set_modal(false);
#endif

}

gint SimpleRequest::delete_event_impl(GdkEventAny*) 
{
#ifndef NDEBUG
 cerr << "Hide the requester" << endl;
#endif

 /* ---- Hide the requester ---- */
 hide();

 /* ---- Don't delete the object ---- */
 return 1;

}
