//-*-C++-*-  
#ifndef _SIMPLEREQUEST_
#define _SIMPLEREQUEST_

#include <gtk--/window.h>
#include <gtk--/label.h>
#include <gtk--/button.h>
#include <gtk--/box.h>
#include <gtk--/separator.h>

#include <string>

class SimpleRequest : public Gtk::Window {

 public:

  /* ---- (Ok|Cancel)Butt = true iff there is a cancel|ok button ---- */
  SimpleRequest(const string &text, 
                bool haveCancelButt = false);

  /* ---- Destructor ---- */
  ~SimpleRequest();

  /* ---- Set the text of body of requester ---- */
  void setText(const string &text);

  /* ---- Raise the requester. Terminate after "ok" if terminate=true ---- */
  void ask(bool terminate);

 private:

  /* ---- VBox holding the 'label', separator and 'actionArea' for buttons ---- */
  Gtk::VBox vbox;
  Gtk::HBox actionArea;

  /* ---- Label and buttons for the requester ---- */
  Gtk::Label label;
  Gtk::Button* okButton;
  Gtk::Button* cancelButton;

 protected:

  virtual void okCallback();
  virtual void cancelCallback();

 private:

  bool termFlag;

  /* ---- Delete event implementation (Hide the requester) ---- */
  gint delete_event_impl(GdkEventAny*);

};
#endif
