//-*-C++-*-  
#include <gtk--/style.h>
#include <gtk/gtkrc.h>
#include <glib.h>

#include <iostream>

#include <MainWindow.h>
#include <config.h>
#include <Global.h>
#include <PMain.h>

#ifdef WITH_DMALLOC 
#include<dmalloc.h>
#endif

/* ---- Global pointer for main window and application ---- */
MainWindow* win = static_cast<MainWindow *>(NULL);

/* ---- Global pointer for application object ---- */
Gtk::PMain* app = static_cast<Gtk::PMain*>(NULL);

int main (int argc, char* argv[])
{
 const int resLen = 2048;
 char resBuffer[resLen];
 char* home = getenv("HOME");

 /* ---- Create name of global rc-file ---- */
 resBuffer[0]='\0';
 (void) snprintf(resBuffer, 
                 resLen - 1,
                 "%s/udcfviewrc",
                 RCDIR); 

 /* ---- Add the global resource file ---- */
 gtk_rc_add_default_file(resBuffer);

 /* ---- Check for valid "HOME" environment variable ---- */
 if (home != static_cast<char*>(NULL)) { 

  /* ---- Create the name of user resource-file ---- */
  resBuffer[0]='\0';
  (void) snprintf(resBuffer, 
                  resLen - 1,
                  "%s/%s/udcfviewrc",
                  home,
                  PRIVATERCDIR); 

#ifndef NDEBUG
  cerr << "Per User resource: " << resBuffer << endl;
#endif

  /* ---- Add the per user rc-file ---- */
  gtk_rc_add_default_file(resBuffer);

 }

 /* ---- Create the application object ---- */
 app = new Gtk::PMain(argc, argv);

 /* ---- Check the creation ---- */
 if (app == static_cast<Gtk::PMain*>(NULL)) {

  /* ---- Give an error and exit ---- */
  cerr << "Can't create application object. Have to quit" << endl;
  exit(EXIT_FAILURE);

 }

 /* ---- Create the main window ---- */
 win = new MainWindow();

 /* ---- Check if the main window exists ---- */
 if (win != static_cast<MainWindow *>(NULL)) {
 
  /* ---- Show it ---- */
  win -> set_title("Profile viewer .... ");
  win -> show();

  /* ---- Start the application ---- */
  app -> run();

 }

 /* ---- Delete the Window ---- */
 if (win != static_cast<MainWindow *>(NULL)) {

  /* ---- Hide it ---- */
  win -> hide(); 

  /* ---- And delete it ---- */
  win -> destroy();
  delete win;

 }

 /* ---- Free unused memory ---- */
 g_blow_chunks();

#ifdef WITH_DMALLOC
 dmalloc_shutdown();
#endif

#ifndef NDEBUG
 cerr << "End of udcfview ---------------------------" << endl;
 g_mem_profile();
 cerr << endl << "End ---------------------------------------" << endl;
#endif

 /* ---- No error occurred ---- */
 return EXIT_SUCCESS;

}
