#include <stdio.h>
#include <errno.h>  
#include <stdlib.h> 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h> 
#include <string.h>
    
void ConnectToFile(const char* filename, int openFlags, int connectTo)
{
 int fileNo;

 /* ---- Open specified filename ---- */
 if ((fileNo = open(filename, openFlags)) == -1) {

  /* ---- Give an error and exit ---- */
  fprintf(stderr, "Can't open %s (%s)!\n", filename, strerror(errno));
  exit(EXIT_FAILURE);

 }            

 /* ---- Try to close 'connectTo' ---- */
 if (close(connectTo) == -1) {

  /* ---- Give an error and exit ---- */
  fprintf(stderr, "Can't close channel (%s)!\n", strerror(errno));
  exit(EXIT_FAILURE);

 }
 
 /* ---- Connect 'connectTo' to file 'fileNo' ---- */
 if (dup(fileNo) == -1) {

  /* ---- Give an error and exit ---- */
  fprintf(stderr, "Can't connect to %s (%s)!\n", filename, strerror(errno));
  exit(EXIT_FAILURE);

 }

 /* ---- Close 'fileNo' since it is connected to 'connectTo' now ---- */
 if (close(fileNo) == -1) {

  /* ---- Give an error and exit ---- */
  fprintf(stderr, "Can't close file after dup (%s)!\n", strerror(errno));

 }

}
